Imports Microsoft.VisualBasic
Imports System
Imports ThinkGeo.MapSuite.Core
Imports ThinkGeo.MapSuite.WebEdition
Imports System.Data.SqlClient
Imports System.Globalization
Imports System.Collections.Generic
Imports System.Collections.ObjectModel
Imports System.Data
Imports System.Web.UI
Imports System.ComponentModel
Partial Class Default2
    Inherits System.Web.UI.Page
    Public inMemoryMarkerOverlay As InMemoryMarkerOverlay = New InMemoryMarkerOverlay()
    Public markerLayer As New InMemoryFeatureLayer()

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        If (Not Page.IsPostBack) Then


            Map1.MapUnit = GeographyUnit.DecimalDegree
            '######
            Map1.MapTools.OverlaySwitcher.Enabled = True
            Map1.MapTools.OverlaySwitcher.BackgroundColor = GeoColor.StandardColors.Gray
            Map1.MapTools.MouseCoordinate.Enabled = True
            Map1.MapTools.PanZoomBar.Enabled = True
            Map1.MapTools.ScaleLine.Enabled = True
            'Map1.MapTools.MiniMap.Enabled = True
            Map1.MapTools.Logo.Enabled = False
            Map1.MapBackground.BackgroundBrush = New GeoSolidBrush(GeoColor.FromHtml("#B3C6D4"))
            Map1.CurrentExtent = New RectangleShape(-8981140.62043, 3314729.94964, -8961649.17822, 3304066.9842)
            Map1.MapUnit = GeographyUnit.Meter

            Map1.MapTools.OverlaySwitcher.Enabled = True
            Map1.MapTools.MouseCoordinate.Enabled = True



            Dim wms As New WmsOverlay("WMS Layer")
            wms.ServerUris.Add(New Uri("http://labs.metacarta.com/wms/vmap0"))
            wms.Parameters.Add("layers", "basic")
            wms.SetBaseEpsgProjection("EPSG:900913")

            Dim google As New GoogleOverlay("Google Map")
            google.GoogleMapType = GoogleMapType.Hybrid
            google.JavaScriptLibraryUri = New Uri(ConfigurationManager.AppSettings("GoogleUri"))
            Map1.CustomOverlays.Add(google)

  

            Dim shapeLayer As InMemoryFeatureLayer = New InMemoryFeatureLayer()
            shapeLayer.ZoomLevelSet.ZoomLevel01.DefaultPointStyle = PointStyles.CreateSimpleCircleStyle(GeoColor.FromArgb(180, 102, 255, 102), 10, GeoColor.StandardColors.DarkGreen, 1)
            shapeLayer.ZoomLevelSet.ZoomLevel01.DefaultLineStyle = LineStyles.CreateSimpleLineStyle(GeoColor.StandardColors.Green, 4, True)
            shapeLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.FromArgb(180, 102, 255, 102), GeoColor.StandardColors.DarkGreen, 1)
            shapeLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20
            shapeLayer.DrawingQuality = DrawingQuality.HighQuality

            Dim dynamicOverlay As LayerOverlay = New LayerOverlay("DynamicOverlay")
            dynamicOverlay.IsBaseOverlay = False
            dynamicOverlay.TileType = TileType.SingleTile
            dynamicOverlay.Layers.Add("shapeLayer", shapeLayer)
            Map1.CustomOverlays.Add(dynamicOverlay)



            Dim markerOverlay As InMemoryMarkerOverlay = New InMemoryMarkerOverlay("MarkerOverlay")

            Dim proj7 As New Proj4Projection
            proj7.InternalProjectionParametersString = Proj4Projection.GetEpsgParametersString(4326)
            proj7.ExternalProjectionParametersString = Proj4Projection.GetGoogleMapParametersString()
            markerOverlay.FeatureSource.Projection = proj7
          
            Dim LocID As String = "Test1"
            Dim feature As New Feature(-94.48242, 38.75977, LocID)
            feature.ColumnValues.Add("LocId", LocID)
            markerOverlay.Features.Add(feature)
            '###################################
            ' Bind the DataSet to the GMap.  Each entry row in the DataSet will create a new GMarker
            Dim txtSQLGal As String
            Dim dtrMark As System.Data.SqlClient.SqlDataReader
            Dim cmdSDG As System.Data.SqlClient.SqlCommand

            Dim SQLDbCon2 As New SqlConnection(ConfigurationManager.AppSettings("connectionString"))
            Dim dtrSDG As System.Data.SqlClient.SqlDataReader
            Dim cmdSDG2 As System.Data.SqlClient.SqlCommand
            Dim sqlText As String
            Dim cmd As New SqlCommand


            Dim SQLDbCon As New SqlConnection(ConfigurationManager.AppSettings("connectionString"))
            Dim SQLWhere As String = " Grouping IS NULL"

            'Dim LocID As String
            'Dim feature As New Feature

            txtSQLGal = "SELECT   LocID, Latitude, Longitude, SFlag, MapLocID FROM vMapLocNE WHERE " & SQLWhere


            Try

                SQLDbCon.Open()
                cmdSDG = New System.Data.SqlClient.SqlCommand(txtSQLGal, SQLDbCon)
                dtrMark = cmdSDG.ExecuteReader(System.Data.CommandBehavior.CloseConnection)

                Do While dtrMark.Read()
                    LocID = dtrMark("LocID").ToString()
                    feature = New Feature(CDbl(dtrMark("Longitude")), CDbl(dtrMark("Latitude")), LocID)
                    feature.ColumnValues.Add("LocId", LocID)
                    markerOverlay.Features.Add(feature)

                Loop

            Finally

                SQLDbCon.Close()

            End Try
            '###############################################

            markerOverlay.ZoomLevelSet.ZoomLevel01.DefaultMarkerStyle.WebImage = New WebImage("../theme/default/img/marker.gif", 21, 25)
            markerOverlay.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20
            Map1.CustomOverlays.Add(markerOverlay)


            '############################################################################




        End If
    End Sub





    Function GetZoomFromScale(ByVal scale As Double, ByVal zoomLevelSets As Collection(Of Double)) As Integer

        Dim zoomLevel As Integer = 0
        Dim counter As Integer = 0

        For Each zoomLevelScale As Double In zoomLevelSets

            If (counter = 0) Then

                counter = counter + 1

            ElseIf (scale <= zoomLevelScale) Then

                counter = counter + 1
                zoomLevel = zoomLevel + 1

            Else

                Exit For
            End If

        Next

        Return zoomLevel

    End Function



End Class
